<?php

namespace BS\ChatGPTQuickReplyBot\Job;

use BS\ChatGPTQuickReplyBot\Listener;
use XF\Job\AbstractJob;

class Answer extends AbstractJob
{
    public function run($maxRunTime)
    {
        $em = \XF::em();
        $thread = $em->find('XF:Thread', $this->data['thread_id'], ['Forum', 'FirstPost']);
        $botUser = Listener::getBot();

        if (! $thread || ! $botUser) {
            return $this->complete();
        }

        /** @var \BS\ChatGPTQuickReplyBot\Service\QuickReply $quickReplyService */
        $quickReplyService = \XF::service('BS\ChatGPTQuickReplyBot:QuickReply', $botUser, $thread);
        $quickReplyService->answer();

        return $this->complete();
    }

    public function getStatusMessage()
    {
        return 'Answering questions...';
    }

    public function canCancel()
    {
        return false;
    }

    public function canTriggerByChoice()
    {
        return false;
    }
}