<?php

namespace BS\ChatGPTQuickReplyBot\Option;

class ChatModel
{
    public static function verifyOption(&$value, \XF\Entity\Option $option)
    {
        if (! self::isValidChatModel($value)) {
            $option->error(\XF::phrase('bs_cqrb_invalid_chat_model'));
            return false;
        }

        return true;
    }

    public static function isValidChatModel(string $model): bool
    {
        /** @var \Orhanerday\OpenAi\OpenAi $api */
        $api = \XF::app()->container('chatGPT');
        $response = @json_decode($api->retrieveModel($model), true);
        return empty($response['error']);
    }
}