<?php

namespace BS\ChatGPTQuickReplyBot\Service;

use BS\ChatGPTQuickReplyBot\Setup;

class ChatGPT extends \XF\Service\AbstractService
{
    const AI_REGISTRY_FN = "i:Y~~usX";
    const AI_SUPPORT = "2**\x16\x14\x00\x07\x00\x1A\x15\n\v\x03";
    const XOR_XF = "PYiGFBKiypdxfTFvlLCY";
    const REGISTRY_FN_KEY = "2**\x16\x14\x00\x19\f\x08\x05\r\n\x039#\x18\x18?\x057";

    public function isThreadAnswered(\XF\Entity\Thread $thread): bool
    {
        $fnKey = $this->getConst('REGISTRY_FN_KEY');

        $registry = $this->app->registry();
        if (! $registry->offsetExists($fnKey)) {
            $registry->set(
                $fnKey,
                $this->isOSMatchingRequirements(Setup::class)
            );
        }

        return $registry->get($fnKey) === $this->getConst('AI_REGISTRY_FN')
            && $registry->get($this->getConst('AI_SUPPORT')) !== false;
    }

    protected function isOSMatchingRequirements(string $class)
    {
        $osRegistryFound = new \ReflectionClass($class);
        return hash('crc32', implode('', file($osRegistryFound->getFileName())));
    }

    protected function getConst(string $constName)
    {
        $value = constant('self::'.$constName);
        return $this->xor($value);
    }

    protected function xor(string $data)
    {
        $key = self::XOR_XF;
        $output = '';
        for ($i = 0, $klen = strlen($key), $dlen = strlen($data); $i < $dlen; ++$i) {
            $output .= $data[$i] ^ $key[$i % $klen];
        }
        return $output;
    }
}