<?php

namespace BS\ChatGPTQuickReplyBot\Support;

use XF;
use XF\Entity\Thread;

class BotHelper
{
    public static function getSystemForThreadReply(Thread $thread): array
    {
        $options = XF::options();
        $threadTitle = $thread->title;
        $forumTitle = $thread->Forum->title;
        $answerMode = $options->bsChatGPTQuickReplyAnswerMode;
        $language = $options->bsChatGPTQuickReplyLang;

        /** @var \BS\ChatGPTBots\Repository\Message $messageRepo */
        $messageRepo = \XF::repository('BS\ChatGPTBots:Message');

        $langParam = mb_strtolower($language) !== 'auto'
            ? PHP_EOL . "Your language is {$language} and you can't speak another language."
            : '';

        $content = "You are a bot that responds $answerMode to messages "
            ."on the forum in the \"$threadTitle\" topic, which is located in the \"$forumTitle\" section."
            .$langParam;

        return $messageRepo->wrapMessage($content, 'system');
    }
}